# nu-enum
[![npm version](https://img.shields.io/npm/v/nu-enum.svg?style=flat-square)](https://www.npmjs.com/package/nu-enum)
[![Build Status](https://travis-ci.org/nulliel/nu-enum.svg?branch=master&style=flat-square)](https://travis-ci.org/nulliel/nu-enum)
[![Codecov](https://img.shields.io/codecov/c/github/nulliel/nu-enum.svg?style=flat-square)](https://codecov.io/gh/nulliel/nu-enum)
[![Dependency Status](https://img.shields.io/david/nulliel/nu-enum.svg?style=flat-square)](https://david-dm.org/nulliel/nu-enum)

Create enum-like objects in JavaScript.

## Install
`npm install nu-enum`

## Usage
nu-enum exposes a single function

### Enum(...args: [...String]) => Enum
Creates an enum with properties `args`.

Enum properties will be an instance of their parent.
```js
import Enum from 'nu-enum';

const RUNFLAGS = Enum('start', 'pause', 'stop');

RUNFLAGS.start instanceof RUNFLAGS // true
RUNFLAGS.pause instanceof RUNFLAGS // true
RUNFLAGS.stop instanceof RUNFLAGS // true
```

Enum properties are unique across enums.
```js
import Enum from 'nu-enum';

const enumA = Enum('same');
const enumB = Enum('same');

enumA.same === enumB.same // false
```

#### Enum.add(arg: String) => Void
Add a property to the enum.

```js
import Enum from 'nu-enum';

const ENUM = Enum('one', 'two', 'three');

ENUM.add('four');

ENUM.four instanceof ENUM // true
```

## License
MIT
