'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
//--------------------------------------------------
// Properties
//--------------------------------------------------
var count = 0;

//--------------------------------------------------
// Factories
//--------------------------------------------------
/**
 * Create a new enum.
 * @public
 *
 * @param {String} [props] Keys to add to the enum.
 * @returns {Enum} Returns an enum wrapper.
 */
function enumFactory() {
  for (var _len = arguments.length, props = Array(_len), _key = 0; _key < _len; _key++) {
    props[_key] = arguments[_key];
  }

  props.forEach(function (prop) {
    if (typeof prop !== 'string') {
      throw new Error('Enum property \'' + prop + '\' must be a string.');
    }
  });

  var Enum = function Enum(item) {
    Object.defineProperty(this, item, {
      enumerable: true,
      configurable: false,
      writable: false,
      value: Symbol(item)
    });
  };

  Object.defineProperty(Enum, 'name', {
    value: 'ENUM_' + count++
  });

  props.forEach(function (prop) {
    Object.defineProperty(Enum, prop, {
      enumerable: true,
      configurable: false,
      writable: false,
      value: new Enum(prop)
    });
  });

  return Enum;
}

//--------------------------------------------------
// Exports
//--------------------------------------------------
// Factories
exports.default = enumFactory;